<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Judul, nomor inventaris" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                    <el-button @click="showFilterDialog = true" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-funnel"></i> Filter
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button v-permission="[null, 'inventory', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Inventaris
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="movements" ref="inventoryTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column  
                fixed="left"              
                label="No. Inventaris"
                width="250">
                <template slot-scope="scope">
                    <span style="color:#3E89FA;">{{ scope.row.number }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Nama Barang"
                width="200">
                <template slot-scope="scope">
                    <span>{{ scope.row.inventory.title }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Penanggung Jawab"
                width="200">
                <template slot-scope="scope">
                    <span>{{ scope.row.name }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Durasi"
                width="150">
                <template slot-scope="scope">
                    <el-progress :text-inside="true" :stroke-width="18" :percentage="progress(scope.row.end_date)" color="rgba(142, 113, 199, 0.7)"></el-progress>
                </template>
            </el-table-column>
            <el-table-column
                align="center"
                label="Kuantitas"
                width="100">
                <template slot-scope="scope">
                    <span>{{ scope.row.quantity }}</span>
                </template>
            </el-table-column> 
            <el-table-column
                align="center"
                label="Biaya"
                width="100">
                <template slot-scope="scope">
                    <span>{{ scope.row.cost.format(2,0,',','.') }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Status"
                width="150">
                <template slot-scope="scope">
                    <el-tag v-if="['returned', 'fixed'].indexOf(scope.row.status) > -1" type="success" size="mini">inventoryStatusTitle[scope.row.status]</el-tag>
                    <el-tag v-else-if="scope.row.status == 'broken'" type="info" size="mini">Rusak</el-tag>
                    <el-tag v-else type="warning" size="mini">{{ inventoryStatusTitle[scope.row.status] }}</el-tag>
                </template>
            </el-table-column> 
            <el-table-column
                label="Terakhir Diubah"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'inventorymovement', 'viewown']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'inventorymovement', 'deleteown']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                    <el-button class="text-info" v-permission="[row, 'inventorymovement', 'viewown']" type="text" @click="handleDownload(row)">Tanda Terima</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog v-loading="filterLoading" title="Filter" :visible.sync="showFilterDialog" width="30%" :show-close="false" @closed="resetForm">
            <aside>
                <el-alert type="info" description="Tampilkan data barang inventaris berdasarkan kriteria di bawah" :closable=false show-icon></el-alert>
            </aside>
            <el-form ref="filter" :model="filter">                
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Kata Kunci" prop="keyword">
                            <el-input ref="keyword" name="keyword" v-model="filter.keyword" placeholder="No. inventaris, nama dan no telepon" autocomplete="off" maxlength="255" clearable></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Status" prop="status">
                            <el-select v-model="filter.status" placeholder="Pilih status" class="width-100" ref="status" name="status" clearable>
                                <el-option
                                    v-for="item in status"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Tanggal Keluar" prop="start_date">
                            <el-date-picker
                                format="yyyy-MM-dd" 
                                value-format="yyyy-MM-dd" 
                                :clearable="false" 
                                :editable="false"
                                :default-value="filter.start_date"
                                v-model="filter.start_date"
                                type="date"
                                placeholder="Pilih tanggal">
                            </el-date-picker>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Tanggal Dikembalikan" prop="end_date">
                            <el-date-picker
                                format="yyyy-MM-dd" 
                                value-format="yyyy-MM-dd" 
                                :clearable="false" 
                                :editable="false"
                                :default-value="filter.end_date"
                                v-model="filter.end_date"
                                type="date"
                                placeholder="Pilih tanggal">
                            </el-date-picker>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24" v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                        <el-form-item label="Perumahan" prop="residential">
                            <el-select v-model="filter.residential" placeholder="Pilih perumahan" class="width-100" ref="residential" name="residential" clearable>
                                <el-option
                                    v-for="item in residentials"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>               
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showFilterDialog = false" size="medium">Batal</el-button>
                <el-button @click="handleSearch" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> Submit
                </el-button>
            </span>
        </el-dialog>

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="inventoryForm" :model="inventoryForm" :rules="inventoryRules">
                <aside>
                    <el-alert type="info" description="Mengatur daftar keluar masuk barang inventaris masing-masing perumahan." :closable=false show-icon></el-alert>
                </aside>
                <el-form-item label="Barang Inventaris" prop="inventory">
                    <el-select
                        ref="inventory"
                        name="inventory"
                        class="width-100"
                        clearable
                        filterable
                        remote
                        :remote-method="getInventories"
                        v-model="inventoryForm.inventory"
                        value-key="id"
                        placeholder="Ketik nama barang"
                        no-data-text="No Data"
                        :loading="inventoryLoading">
                        <el-option
                            v-for="item in inventories"
                            :key="item.id"
                            :label="item.title"
                            :value="item.id">             
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-row :gutter="20">
                    <el-col :lg="16" :md="24" :xs="24">
                        <el-form-item label="Penanggung Jawab" prop="name">
                            <el-input ref="name" name="name" v-model="inventoryForm.name" placeholder="Nama penanggung jawab" autocomplete="off" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="8" :md="24" :xs="24">
                        <el-form-item label="No. Handphone" prop="phone">
                            <el-input type="number" ref="phone" name="phone" v-model="inventoryForm.phone" placeholder="No. Handphone" autocomplete="off" min="0" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                </el-row> 
                <el-row :gutter="20">
                    <el-col :lg="16" :md="24" :xs="24">
                        <el-form-item label="Alamat" prop="address">
                            <el-input ref="address" name="address" v-model="inventoryForm.address" placeholder="Alamat penanggung jawab" autocomplete="off" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="8" :md="24" :xs="24">
                        <el-form-item label="Kode Pos" prop="region">
                            <el-select
                                ref="region"
                                name="region"
                                class="width-100"
                                clearable
                                filterable
                                remote
                                :remote-method="getRegions"
                                v-model="inventoryForm.region"
                                value-key="id"
                                placeholder="Ketik kode pos"
                                no-data-text="No Data"
                                :loading="regionLoading">
                                <el-option
                                    v-for="item in regions"
                                    :key="item.id"
                                    :label="item.name+' ('+item.postal+')'"
                                    :value="item.id">     
                                    <span style="float: left">{{ item.name }}</span>
                                    <strong style="float: right; color: #8492a6; font-size: 13px">{{ getAdministrative(item) }}</strong>                   
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>                                     
                <el-row :gutter="20">
                    <el-col :lg="8" :md="24" :sm="24">
                        <el-form-item label="Durasi" prop="duration">
                            <el-date-picker
                                format="yyyy-MM-dd" 
                                value-format="yyyy-MM-dd" 
                                :clearable="false" 
                                :editable="false"
                                v-model="inventoryForm.duration"
                                type="daterange"
                                start-placeholder="Dari tanggal"
                                end-placeholder="Sampai Tanggal">
                            </el-date-picker>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="8" :md="24" :sm="24">
                        <el-form-item label="Kuantitas" prop="quantity">
                            <el-input-number v-model="inventoryForm.quantity" ref="quantity" name="quantity" :min="1"></el-input-number>
                        </el-form-item>
                    </el-col>                    
                    <el-col :lg="8" :md="24" :sm="24">
                        <el-form-item label="Biaya" prop="cost">                        
                            <el-input type="number" ref="cost" name="cost" v-model="inventoryForm.cost" placeholder="Catatan" autocomplete="off" min="0">
                                <template slot="prepend">Rp</template>
                            </el-input>
                        </el-form-item>
                    </el-col>
                </el-row> 
                <el-form-item label="Catatan" prop="description">
                    <el-input type="textarea" ref="description" name="description" v-model="inventoryForm.description" placeholder="Catatan" autocomplete="off" maxlength="255" :autosize="{ minRows: 2, maxRows: 4}" show-word-limit></el-input>
                </el-form-item> 
                <el-row :gutter="20" v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item label="Inventaris Perumahan" prop="residential">
                            <el-select v-model="inventoryForm.residential" placeholder="Pilih perumahan" class="width-100" ref="residential" name="residential">
                                <el-option
                                    v-for="item in residentials"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col> 
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Dibuat Oleh" prop="author">
                            <el-select 
                                :disabled="inventoryForm.residential == null"
                                v-model="inventoryForm.author" 
                                placeholder="Ketik nama warga" 
                                class="width-100" 
                                ref="author" 
                                name="author"
                                clearable
                                filterable
                                remote
                                :remote-method="getUsers"
                                value-key="id"
                                >
                                <el-option
                                    v-for="item in users"
                                    :key="item.id"
                                    :label="item.profile.fullname"
                                    :value="item.id">
                                    <span style="float: left">{{ item.profile.fullname }}</span>
                                    <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.role.name }}</strong>
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>   
                </el-row>      
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item label="Status" prop="status">
                            <el-select v-model="inventoryForm.status" placeholder="Pilih status" class="width-100" ref="status" name="status">
                                <el-option
                                    v-for="item in status"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>
                <h3>Ditandatangani Oleh:</h3> 
                <div v-for="(item, index) of inventoryForm.signedby" :key="index" class="dynamic-list">
                    <el-row :gutter="20">
                        <el-col :lg="12" :md="24" :sm="24">
                            <el-form-item label="Nama" :prop="item.name">
                                <el-input ref="name" name="name" v-model="item.name" placeholder="Nama lengkap" autocomplete="off" maxlength="255" show-word-limit></el-input>
                            </el-form-item> 
                        </el-col>
                        <el-col :lg="12" :md="24" :sm="24">
                            <el-form-item label="Jabatan" :prop="item.position">
                                <el-input ref="position" name="position" v-model="item.position" placeholder="Jabatan/Posisi" autocomplete="off" maxlength="255" show-word-limit></el-input>
                            </el-form-item> 
                        </el-col>
                    </el-row>
                    <el-form-item>
                        <el-button class="float-right margin-small-left" @click="deleteAction(index)" v-if="index > 0" icon="el-icon-delete" type="danger" size="mini">Hapus</el-button>
                        <el-button class="float-right" @click="addAction" v-if="(index + 1) == inventoryForm.signedby.length" icon="el-icon-plus" type="success" size="mini"> Tambah</el-button>                        
                    </el-form-item>
                </div>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'inventory', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>                
            </span>
        </el-dialog>

    </div>
</template>
<script>
import html2pdf from 'html2pdf.js';
import moment  from 'moment';
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';

export default {
    name: 'InventoryMovement',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        var validateResidential = (rule, value, callback) => {
            if(['root', 'owner'].indexOf(this.me.role.slug) > -1 && this.inventoryForm.residential == null){
                return callback(new Error('Perumahan wajib dipilih'));
            }
            callback();
        };

        var validateAuthor = (rule, value, callback) => {
            if(['root', 'owner'].indexOf(this.me.role.slug) > -1 && this.inventoryForm.residential != null && this.inventoryForm.author == null){
                return callback(new Error('Inventaris dibuat oleh wajib dipilih'));
            }
            callback();
        };

        return {            
            tableLoading: false,
            dialogLoading: false,
            filterLoading: false,
            inventoryLoading: false,
            regionLoading: false,
            inventoryStatusTitle: {
                onloan: 'Dipinjam',
                rentedout: 'Disewa',
                beingrepaired: 'Diperbaiki',
                broken: 'Rusak',
                returned: 'Telah Dikembalikan',
                fixed: 'Telah Diperbaiki',
                waiting: 'Menunggu Persetujuan',
                missing: 'Hilang'
            },
            status: [{
                label: 'Menunggu Persetujuan',
                value: 'waiting'
            }, {
                label: 'Telah Diperbaiki',
                value: 'fixed'
            }, {
                label: 'Sedang Dipinjam',
                value: 'onloan'
            }, {
                label: 'Sedang Disewa',
                value: 'rentedout'
            }, {
                label: 'Sedang Diperbaiki',
                value: 'beingrepaired'
            }, {
                label: 'Rusak',
                value: 'broken'
            }, {
                label: 'Hilang',
                value: 'missing'
            }, {
                label: 'Telah Dikembalikan',
                value: 'returned'
            }],
            filter: {
                keyword: '',
                status: null,
                duration: null,
                residential: null
            },
            showDialog: false,
            showFilterDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Inventaris',
                create: 'Tambah Inventaris'
            },
            inventoryForm: {
                id: null,
                name: '',
                address: '',
                phone: '',
                duration: [new Date(), new Date()],
                description: '',
                quantity: 1,
                cost: 0,
                status: null,
                region: null,
                author: null,
                residential: null,
                inventory: null,
                archived: false,
                signedby: [{
                    name: '',
                    position: ''
                }]
            },
            inventoryRules: {
                inventory: [{
                    required: true, message: 'Barang inventaris wajib dipilih', trigger: 'change'
                }],
                name: [{ 
                    required: true, message: 'Nama penanggung jawab wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang nama penanggung jawab maksimal 255 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,?]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                address: [{
                    required: true, message: 'Alamat penanggung jawab wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Alamat penanggung jawab maksimal 255 karakter', trigger: 'blur'
                }],
                phone: [{
                    required: true, message: 'Alamat penanggung jawab wajib diisi', trigger: 'blur'
                },{
                    max: 25, message: 'Panjang no. handphone pemilik maksimal 25 karakter', trigger: 'blur'
                }, {
                    pattern: /\(?(?:\+628|628|08)(?:\d{2,3})?\)?[ .-]?\d{2,4}[ .-]?\d{2,4}[ .-]?\d{2,4}/, message: 'No. Handphone harus diawali dengan 08, +628 atau 628', trigger: 'blur'
                }],
                duration: [{
                    required: true, message: 'Durasi wajib dipilih', trigger: 'change'
                }],
                quantity: [{
                    required: true, message: 'Kuantitas wajib diisi', trigger: 'change'
                }],
                cost: [{
                    required: true, message: 'Biaya wajib diisi', trigger: 'blur'
                }],
                status: [{
                    required: true, message: 'Status barang inventaris wajib diisi', trigger: 'change'
                }],
                region: [{
                    required: true, message: 'Kode pos wajib diisi', trigger: 'change'
                }],
                residential: [{
                    validator: validateResidential, trigger: 'change'
                }],
                author: [{
                    validator: validateAuthor, trigger: 'change'
                }]
            },
            uploadFileList: [],
            uploadURL: ''
        };
    },
    computed: {
        tableHeight,
        ...mapGetters('auth', ['token']),
        ...mapGetters('user', ['me', 'users']),
        ...mapGetters('category', ['categories']),
        ...mapGetters('residential', ['residentials']),
        ...mapGetters('inventory', ['inventories']),
        ...mapGetters('region', ['regions']),
        ...mapGetters('movement', [
            'movements',
            'pagination'
        ]),
    },
    created() {
        this.getMovements();
        this.getResidentials();
    },
    methods: {
        playSound,
        dateFormat,
        isNumeric(n) {
            return !isNaN(parseFloat(n)) && isFinite(n);
        },
        progress(date){
            var now = moment(new Date());
            var end = moment(new Date(date));

            if(now > end){
                return 100;
            }

            var dur = moment.duration(end.diff(now));
            var days = dur.asDays();
            var percentage = Math.round(100 / days);
            return percentage;
        },
        getAdministrative(region, level){
            var temp = [];
            level = level || 0;

            if(region.parents){
                temp.push(region.name);
                level++;
                temp.push.apply(temp, this.getAdministrative(region.parents, level));
            }else{
                temp.push(region.name);
            }

            if(temp.length == 4){
                temp.splice(0,2);
                return temp.join(', ');
            }
            
            return temp;
        },
        getMovements() {
            this.tableLoading = true;
            this.$store.dispatch('movement/getMovements', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getInventories(q) {
            if(q && q.trim().length >= 3){
                this.tableLoading = true;
                this.$store.dispatch('inventory/getInventories', {
                    q: q,
                    page: this.pagination.page,
                    perpage: this.pagination.perpage
                }).then(() => {
                    this.tableLoading = false;
                });
            }
        },
        getResidentials() {
            this.tableLoading = true;
            this.$store.dispatch('residential/getResidentials', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getUsers(q) {
            if(q && q.trim().length >= 3){
                this.tableLoading = true;
                this.$store.dispatch('user/getUsers', {
                    q: q,
                    residential: this.inventoryForm.residential,
                    page: this.pagination.page,
                    perpage: 100
                }).then(() => {
                    this.tableLoading = false;
                });
            }
        },
        getRegions(q) {
            if(q && q.trim().length >= 3){
                this.tableLoading = true;
                this.$store.dispatch('region/getRegions', {
                    q: q,
                    page: this.pagination.page,
                    perpage: this.pagination.perpage
                }).then(() => {
                    this.tableLoading = false;
                });
            }
        },
        handleSearch(){

            this.showFilterDialog = false;

            let payload = {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }

            if(this.filter.status != null){
                payload['status'] = this.filter.status;
            }

            if(this.filter.residential != null){
                payload['residential'] = this.filter.residential;
            }

            if(this.filter.duration != null){
                payload['duration'] = this.filter.duration;
            }

            this.tableLoading = true;
            this.$store.dispatch('movement/getMovements', payload).then(() => {
                this.tableLoading = false;
            });
        },
        handleDownload(row){
            moment.locale('id');

            var self = this;

            var html = '<div id="pdf" style="font-size:13px!important;line-height:1.6em;">';

            html += '<table style="width:100%;">'+
                        '<tr>'+
                            '<td style="width: 25%;" valign="top">'+
                                '<img src="http://my.ringsatu.id/logo-text-only.png" width="200">'+                                          
                            '</td>'+
                            '<td style="width: 75%;" valign="top" align="right">'+
                                '<strong>'+row.residential.name+'</strong><br>'+
                                '<small>'+row.residential.address+' '+row.residential.administrative_region[0]+', '+row.residential.administrative_region[1]+', '+row.residential.administrative_region[2]+',<br>'+
                                row.residential.administrative_region[3]+', '+row.residential.administrative_region[4]+'</small>'+
                            '</td>'+
                        '</tr>'+
                    '</table>'+
                    '<strong style="display:block;text-align:center;margin:50px 0;font-size: 20px;">TANDA TERIMA BARANG</strong>'+
                    '<table style="width:100%;margin-top:50px;">'+
                        '<tr>'+
                            '<td style="width: 25%;padding:10px 0;" valign="top">'+
                                '<strong>Nomor</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:10px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>: '+row.number+'</span>'+         
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td style="width: 25%;padding:10px 0;" valign="top">'+
                                '<strong>Telah Terima Dari</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:10px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>: '+row.author.profile.fullname+ ' ('+row.author.role.name+')'+'</span>'+
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td style="width: 25%;padding:10px 0;" valign="top">'+
                                '<strong>Kepada</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:10px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>: '+row.name+'</span>'+
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td style="width: 25%;padding:10px 0;" valign="top">'+
                                '<strong>Alamat</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:10px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>:'+row.address+', '+row.administrative_region.join(', ')+'</span>'+                
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td style="width: 25%;padding:10px 0;" valign="top">'+
                                '<strong>No. Handphone</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:10px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>: '+row.phone+'</span>'+         
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td style="width: 25%;padding:10px 0;" valign="top">'+
                                '<strong>Barang Berupa</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:10px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>: '+row.quantity+' Unit '+row.inventory.title+'</span>'+             
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td style="width: 25%;padding:10px 0;" valign="top">'+
                                '<strong>Untuk</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:10px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span style="font-weight:bold;">: '+self.inventoryStatusTitle[row.status].toUpperCase()+'</span>'+             
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td style="width: 25%;padding:10px 0;" valign="top">'+
                                '<strong>Selama</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:10px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>: '+moment(row.start_date).format('DD/MM/YYYY')+' - '+moment(row.end_date).format('DD/MM/YYYY')+'</span>'+             
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td style="width: 25%;padding:10px 0;" valign="top">'+
                                '<strong>Biaya</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:10px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>: Rp '+row.cost.format(2,0,',','.')+'</span>'+             
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td style="width: 25%;padding:10px 0;" valign="top">'+
                                '<strong>Catatan</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:10px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>: '+row.description+'</span>'+             
                            '</td>'+
                        '</tr>'+                        
                        '</table>'+
                        '<table style="width:100%;margin-top:50px;">'+
                            '<tr>'+
                                '<td style="width: 100%;" valign="top">'+
                                    '<strong>'+row.residential.administrative_region[2].replace(/(Kota|Kab)/g, '')+', '+moment(row.created).format('DD MMMM YYYY')+'</strong>'+ 
                                '</td>'+
                            '</tr>'+
                        '</table>';

                    if(row.signs.length){                        
                        html += '<table style="width:100%;margin-top:50px;">'+
                                '<tr>';

                            var percent = (100/row.signs.length);
                            
                            for(const x of row.signs){
                                    html += '<td style="width: '+percent+'%;">'+
                                        '<span style="text-align:center;">'+
                                            '<u>'+x.name+'</u><br>'+ x.position +
                                        '</span>'+                  
                                    '</td>';
                            }
                        html += '</tr>'+
                            '</table>';
                    }
                    
                    html += '<br>'+
                        '<small>Tanda terima ini merupakan bukti yang sah antara kedua belah pihak.</small>'+
                    '</div>';

            var opt = {
                margin: 1,
                filename: row.inventory.title+'-'+self.inventoryStatusTitle[row.status]+'.pdf',
                image: { type: 'jpeg', quality: 0.98 },
                pagebreak: { mode: ['avoid-all', 'css', 'legacy'] },
                html2canvas: { scale: 2 },
                jsPDF: { unit: 'in', format: 'a4', orientation: 'portrait' }
            };

            // New Promise-based usage:
            html2pdf().set(opt).from(html).save();

        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;          
            this.$nextTick(() => {
                this.$refs['inventoryForm'].clearValidate();
            });
        },
        handleEdit(inventory){
            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.inventoryForm.id = inventory.id;
            this.inventoryForm.name = inventory.name;            
            this.inventoryForm.address = inventory.address;
            this.inventoryForm.phone = inventory.phone;
            this.inventoryForm.region = inventory.region.id;
            this.inventoryForm.quantity = inventory.quantity;
            this.inventoryForm.cost = inventory.cost;
            this.inventoryForm.description = inventory.description;
            this.inventoryForm.inventory = inventory.inventory.id;
            this.inventoryForm.status = inventory.status;
            this.inventoryForm.duration = [new Date(inventory.start_date), new Date(inventory.end_date)];
            this.inventoryForm.author = inventory.author.id; 
            this.inventoryForm.residential = inventory.residential.id; 
            this.inventoryForm.archived = inventory.archived;

            if(inventory.signs.length){
                this.inventoryForm.signedby = [];
                for(const x of inventory.signs){
                    this.inventoryForm.signedby.push({
                        name: x.name,
                        position: x.position
                    });
                }
            }

            this.getInventories(inventory.inventory.title);
            this.getUsers(inventory.author.profile.fullname);
            this.getRegions(inventory.region.postal);

            this.$nextTick(() => {
                this.$refs['inventoryForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.inventoryForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'movement/addMovement';
                        payload = {
                            name: this.inventoryForm.name,
                            address: this.inventoryForm.address,
                            phone: this.inventoryForm.phone,
                            description: this.inventoryForm.description,
                            quantity: this.inventoryForm.quantity,
                            cost: this.inventoryForm.cost,
                            status: this.inventoryForm.status,
                            duration: this.inventoryForm.duration,
                            author: this.inventoryForm.author,
                            residential: this.inventoryForm.residential,
                            inventory: this.inventoryForm.inventory,
                            region: this.inventoryForm.region,
                            signedby: this.inventoryForm.signedby
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'movement/editMovement';
                        payload = {
                            id: this.inventoryForm.id,
                            name: this.inventoryForm.name,
                            address: this.inventoryForm.address,
                            phone: this.inventoryForm.phone,
                            description: this.inventoryForm.description,
                            quantity: this.inventoryForm.quantity,
                            cost: this.inventoryForm.cost,
                            status: this.inventoryForm.status,
                            duration: this.inventoryForm.duration,
                            author: this.inventoryForm.author,
                            residential: this.inventoryForm.residential,
                            inventory: this.inventoryForm.inventory,
                            region: this.inventoryForm.region,
                            archived: this.inventoryForm.archived,
                            signedby: this.inventoryForm.signedby
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;
                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(inventory){
            this.$confirm('Anda mencoba untuk menghapus data barang inventaris, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('movement/deleteMovement', {
                    id: inventory.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.inventoryForm = {
                id: null,
                name: '',
                address: '',
                phone: '',
                duration: [new Date(), new Date()],
                description: '',
                quantity: 1,
                cost: 0,
                status: null,
                region: null,
                author: null,
                residential: null,
                inventory: null,
                archived: false,
                signedby: [{
                    name: '',
                    position: ''
                }]
            }

        },
        addAction() {
            this.inventoryForm.signedby.push({
                name: '',
                position: ''
            });
        },
        deleteAction(index) {
            for(const [i, v] of this.inventoryForm.signedby.entries()){
                if(i == index){
                    this.inventoryForm.signedby.splice(i, 1);                    
                    break;
                }
            }
        }
    }

}
</script>
